package com.yizhi.message.application.controller.manage;


import com.yizhi.message.application.service.MessageRemindService;
import com.yizhi.message.application.vo.MessageRemindVo;
import com.yizhi.message.application.vo.MessageVo;
import com.yizhi.util.application.domain.Response;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author hutao123
 * @since 2019-09-09
 */
@RestController
@Api(tags = "待发消息接口")
@RequestMapping("/manage/messageRemind")
public class MessageRemindComtroller {

    @Autowired
    private MessageRemindService messageRemindService;

    /**
     * 保存各业务设置的提醒
     *
     * @param vo
     * @return
     */
    @PostMapping("/insert")
    @ApiOperation(value = "保存待发消息(提醒)", response = String.class)
    public Response insert(@ApiParam("vo") @RequestBody MessageRemindVo vo) {
        if (vo.getMessageContext() == null || vo.getRelationType() == null
                || vo.getRelationId() == null || vo.getMessageId() == null
                || vo.getSendType() == null || vo.getVisibleRange() == null) {
            return Response.fail("缺少必要参数");
        }
        Integer integer = messageRemindService.insertMessageRemind(vo);
        if (integer == 1) {
            return Response.ok("保存成功");
        }
        return Response.fail("操作失败");
    }

    /**
     * 给各业务回显已设置的提醒
     *
     * @param relationType
     * @param relationId
     * @return
     */

    @GetMapping("/get")
    @ApiOperation(value = "回显各业务的消息提醒", response = MessageVo.class)
    public Response get(@ApiParam("relationType") @RequestParam("relationType") Integer relationType,
                        @ApiParam("relationId") @RequestParam("relationId") Long relationId) {

        return Response.ok(messageRemindService.get(relationType, relationId));
    }

    /**
     * 修改消息提醒（包含删除提醒）
     *
     * @param vo
     * @return
     */

    @PostMapping("/update")
    @ApiOperation(value = "修改待发消息(提醒)", response = String.class)
    public Response update(@ApiParam("vo") @RequestBody MessageRemindVo vo) {
        if (vo.getIsChangge() == true) {
            if (vo.getMessageContext() == null || vo.getRelationType() == null
                    || vo.getRelationId() == null || vo.getMessageId() == null
                    || vo.getSendType() == null || vo.getVisibleRange() == null) {
                return Response.fail("缺少必要参数");
            }
        }
        Integer integer = messageRemindService.updateMessageRemind(vo);
        if (integer == 1) {
            return Response.ok("修改成功");
        }
        return Response.fail("操作失败");
    }
}

